/* Removes a useless entry from OS2.INI generated
    by E-Teller 1.3.

    del_err.cmd will first confirm the deletion.
*/

'@echo off'
'cls'
say 'DEL_ERR is used to remove a useless entry in your OS2.INI file'
say 'which was added by E-Teller 1.3.'
say ''
say 'It searches for an app named "Main".  If it finds one, it will'
say 'display the keys which the app contains and ask you if you want'
say 'to delete the entire app, individual keys, or do nothing.'
say ''
say 'Proceed (y/n)?'
parse upper pull answer .
if answer = 'N' then
   exit
say ''
say 'Searching...'
say ''
if RxFuncQuery( 'SysIni' )then do
    call RxFuncAdd 'SysIni', 'RexxUtil', 'SysIni'
end

/* Get Account Information */
call SysIni 'User', 'ALL:', 'search'
do i = 1 to search.0
   if search.i = 'Main' then
      signal FixError
end
say ''
say '"Main" app not found.'
say 'You can now delete the del_err.cmd script.'
say ''
exit

FixError:
call SysIni 'User', 'Main', 'ALL:', 'error'
if error.0 = 0 then do
   say ''
   say '"Main" app found, but it is empty.'
   say 'Remove the empty "Main" app (y/n)?'
   parse upper pull answer .
   if answer = 'Y' then
      ok = SysIni( 'User', 'Main', 'DELETE:' )
      if ok = 'ERROR:' then do
         say ''
         say 'Removal was unsuccessful.'
         exit
      end
      if ok <> 'ERROR:' then do
         say ''
         say '"Main" app successfully removed.'
         say 'You can now delete the del_err.cmd script.'
         exit
      end
   end
   if answer <> 'Y' then do
      say ''
      say 'Removal aborted.'
      exit
end
say ''
say 'Keys found:'
do i = 1 to error.0
   say '   'error.i
end
say ''
say 'The useless values should be one or all of the following:'
say '    LastCheque'
say '    BackupOnExit'
say '    SavePayees'
say '    SaveMemos'
say '    AutoOpen'
say ''
say 'Should del_err now remove the "Main" app and all its keys (y/n)?'
parse upper pull answer .
if answer = 'Y' then do
   ok = SysIni( 'User', 'Main', 'DELETE:' )
   if ok = 'ERROR:' then do
      say ''
      say 'Removal was unsuccessful.'
      exit
   end
   if ok <> 'ERROR:' then do
      say ''
      say '"Main" app successfully removed.'
      exit
   end
end
if answer <> 'Y' then do
   say ''
   say 'Should del_err remove specific keys but leave the "Main" app alone (y/n)?'
   parse upper pull answer .
   if answer = 'N' then
      exit
   else
   do i = 1 to error.0
      say 'Remove key:  'error.i' (y/n)'
      parse upper pull answer .
      if answer = 'Y' then do
         ok = SysIni( 'User', 'Main', error.i, 'DELETE:' )
         if ok = 'ERROR:' then do
            say ''
            say 'Removal of 'error.i' was unsuccessful.'
         end
      end
   end
end
say ''
say 'Process complete.'
